/**
 * generated by Xtext 2.25.0
 */
package org.xtext.example.methodname.methodName.impl;

import org.eclipse.emf.common.notify.Notification;

import org.eclipse.emf.ecore.EClass;

import org.eclipse.emf.ecore.impl.ENotificationImpl;

import org.xtext.example.methodname.methodName.CardinalityModifier;
import org.xtext.example.methodname.methodName.MethodNamePackage;
import org.xtext.example.methodname.methodName.Sentiment;
import org.xtext.example.methodname.methodName.SynonymConst;

/**
 * <!-- begin-user-doc -->
 * An implementation of the model object '<em><b>Synonym Const</b></em>'.
 * <!-- end-user-doc -->
 * <p>
 * The following features are implemented:
 * </p>
 * <ul>
 *   <li>{@link org.xtext.example.methodname.methodName.impl.SynonymConstImpl#isHasNot <em>Has Not</em>}</li>
 *   <li>{@link org.xtext.example.methodname.methodName.impl.SynonymConstImpl#getValue <em>Value</em>}</li>
 *   <li>{@link org.xtext.example.methodname.methodName.impl.SynonymConstImpl#getCard <em>Card</em>}</li>
 *   <li>{@link org.xtext.example.methodname.methodName.impl.SynonymConstImpl#getSentiment <em>Sentiment</em>}</li>
 * </ul>
 *
 * @generated
 */
public class SynonymConstImpl extends ExprImpl implements SynonymConst
{
  /**
   * The default value of the '{@link #isHasNot() <em>Has Not</em>}' attribute.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @see #isHasNot()
   * @generated
   * @ordered
   */
  protected static final boolean HAS_NOT_EDEFAULT = false;

  /**
   * The cached value of the '{@link #isHasNot() <em>Has Not</em>}' attribute.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @see #isHasNot()
   * @generated
   * @ordered
   */
  protected boolean hasNot = HAS_NOT_EDEFAULT;

  /**
   * The default value of the '{@link #getValue() <em>Value</em>}' attribute.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @see #getValue()
   * @generated
   * @ordered
   */
  protected static final String VALUE_EDEFAULT = null;

  /**
   * The cached value of the '{@link #getValue() <em>Value</em>}' attribute.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @see #getValue()
   * @generated
   * @ordered
   */
  protected String value = VALUE_EDEFAULT;

  /**
   * The default value of the '{@link #getCard() <em>Card</em>}' attribute.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @see #getCard()
   * @generated
   * @ordered
   */
  protected static final CardinalityModifier CARD_EDEFAULT = CardinalityModifier.CARD_1;

  /**
   * The cached value of the '{@link #getCard() <em>Card</em>}' attribute.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @see #getCard()
   * @generated
   * @ordered
   */
  protected CardinalityModifier card = CARD_EDEFAULT;

  /**
   * The default value of the '{@link #getSentiment() <em>Sentiment</em>}' attribute.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @see #getSentiment()
   * @generated
   * @ordered
   */
  protected static final Sentiment SENTIMENT_EDEFAULT = Sentiment.SENT_UNSPECIFIED;

  /**
   * The cached value of the '{@link #getSentiment() <em>Sentiment</em>}' attribute.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @see #getSentiment()
   * @generated
   * @ordered
   */
  protected Sentiment sentiment = SENTIMENT_EDEFAULT;

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  protected SynonymConstImpl()
  {
    super();
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  @Override
  protected EClass eStaticClass()
  {
    return MethodNamePackage.Literals.SYNONYM_CONST;
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  @Override
  public boolean isHasNot()
  {
    return hasNot;
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  @Override
  public void setHasNot(boolean newHasNot)
  {
    boolean oldHasNot = hasNot;
    hasNot = newHasNot;
    if (eNotificationRequired())
      eNotify(new ENotificationImpl(this, Notification.SET, MethodNamePackage.SYNONYM_CONST__HAS_NOT, oldHasNot, hasNot));
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  @Override
  public String getValue()
  {
    return value;
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  @Override
  public void setValue(String newValue)
  {
    String oldValue = value;
    value = newValue;
    if (eNotificationRequired())
      eNotify(new ENotificationImpl(this, Notification.SET, MethodNamePackage.SYNONYM_CONST__VALUE, oldValue, value));
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  @Override
  public CardinalityModifier getCard()
  {
    return card;
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  @Override
  public void setCard(CardinalityModifier newCard)
  {
    CardinalityModifier oldCard = card;
    card = newCard == null ? CARD_EDEFAULT : newCard;
    if (eNotificationRequired())
      eNotify(new ENotificationImpl(this, Notification.SET, MethodNamePackage.SYNONYM_CONST__CARD, oldCard, card));
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  @Override
  public Sentiment getSentiment()
  {
    return sentiment;
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  @Override
  public void setSentiment(Sentiment newSentiment)
  {
    Sentiment oldSentiment = sentiment;
    sentiment = newSentiment == null ? SENTIMENT_EDEFAULT : newSentiment;
    if (eNotificationRequired())
      eNotify(new ENotificationImpl(this, Notification.SET, MethodNamePackage.SYNONYM_CONST__SENTIMENT, oldSentiment, sentiment));
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  @Override
  public Object eGet(int featureID, boolean resolve, boolean coreType)
  {
    switch (featureID)
    {
      case MethodNamePackage.SYNONYM_CONST__HAS_NOT:
        return isHasNot();
      case MethodNamePackage.SYNONYM_CONST__VALUE:
        return getValue();
      case MethodNamePackage.SYNONYM_CONST__CARD:
        return getCard();
      case MethodNamePackage.SYNONYM_CONST__SENTIMENT:
        return getSentiment();
    }
    return super.eGet(featureID, resolve, coreType);
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  @Override
  public void eSet(int featureID, Object newValue)
  {
    switch (featureID)
    {
      case MethodNamePackage.SYNONYM_CONST__HAS_NOT:
        setHasNot((Boolean)newValue);
        return;
      case MethodNamePackage.SYNONYM_CONST__VALUE:
        setValue((String)newValue);
        return;
      case MethodNamePackage.SYNONYM_CONST__CARD:
        setCard((CardinalityModifier)newValue);
        return;
      case MethodNamePackage.SYNONYM_CONST__SENTIMENT:
        setSentiment((Sentiment)newValue);
        return;
    }
    super.eSet(featureID, newValue);
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  @Override
  public void eUnset(int featureID)
  {
    switch (featureID)
    {
      case MethodNamePackage.SYNONYM_CONST__HAS_NOT:
        setHasNot(HAS_NOT_EDEFAULT);
        return;
      case MethodNamePackage.SYNONYM_CONST__VALUE:
        setValue(VALUE_EDEFAULT);
        return;
      case MethodNamePackage.SYNONYM_CONST__CARD:
        setCard(CARD_EDEFAULT);
        return;
      case MethodNamePackage.SYNONYM_CONST__SENTIMENT:
        setSentiment(SENTIMENT_EDEFAULT);
        return;
    }
    super.eUnset(featureID);
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  @Override
  public boolean eIsSet(int featureID)
  {
    switch (featureID)
    {
      case MethodNamePackage.SYNONYM_CONST__HAS_NOT:
        return hasNot != HAS_NOT_EDEFAULT;
      case MethodNamePackage.SYNONYM_CONST__VALUE:
        return VALUE_EDEFAULT == null ? value != null : !VALUE_EDEFAULT.equals(value);
      case MethodNamePackage.SYNONYM_CONST__CARD:
        return card != CARD_EDEFAULT;
      case MethodNamePackage.SYNONYM_CONST__SENTIMENT:
        return sentiment != SENTIMENT_EDEFAULT;
    }
    return super.eIsSet(featureID);
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  @Override
  public String toString()
  {
    if (eIsProxy()) return super.toString();

    StringBuilder result = new StringBuilder(super.toString());
    result.append(" (hasNot: ");
    result.append(hasNot);
    result.append(", value: ");
    result.append(value);
    result.append(", card: ");
    result.append(card);
    result.append(", sentiment: ");
    result.append(sentiment);
    result.append(')');
    return result.toString();
  }

} //SynonymConstImpl
